
## Install and load Required packages:
list.of.packages <- c("ggplot2","stargazer", "pBrackets","grDevices","BayesFactor")
new.packages <- list.of.packages[!(list.of.packages %in% installed.packages()[,"Package"])]
if(length(new.packages)) install.packages(new.packages)

lapply(list.of.packages, library, character.only = TRUE)

## set work directory @@

  setwd('type_here_your_own_directory')
  savehere="./figure"
  source('./multiplot.R')


star <- function(p){
  if (p<0.01) {return("***")}
  else if (p<0.05) {return("**")}
  else if (p<0.1) {return("*")}
  else {return("n.s")}
}

####################################
##### Read and process data########
###################################

data <- read.csv('Main_data_six.csv',colClasses="character")
data$tr <- data$before
data$tr [data$before==1]<- "Before-6"
data$tr [data$before==0]<- "After-6"
grep('a..a..',data$pattern)
data$aa <- "naa"
data$aa[grep('a..a..',data$pattern)] <- "aa"
table(list(data$aa,data$before))
as.data <- data[c(grep('a..b..',data$pattern), grep('b..a..',data$pattern)),]
table(list(as.data$pattern, as.data$tr))


datas <- read.csv('Main_data_single.csv',colClasses="character",na.strings="")
cc<- do.call(rbind,sapply(datas$cpattern,strsplit,split=""))
datas <- data.frame(datas,cc)
tochange <- grep("^X",colnames(datas))
colnames(datas)[tochange] <- c("col","pattern")
datas$aa <- "naa"
datas$aa[datas$pattern=="a"]<-"aa"
datas$tr <- rep("Single",nrow(datas))

datat <- read.csv('Main_data_two.csv',colClasses="character")
datat$tr <- datat$before
datat$tr [datat$before==1]<- "Before"
datat$tr [datat$before==0]<- "After"
datat$aa <- "naa"
datat$aa[datat$pattern=="aa"] <- "aa"


nbefore=nrow(data[data$before==1,])
nafter=nrow(data[data$before==0,])

nsingle=nrow(datas_narm)

nbefore2=nrow(datat[datat$before==0,])
nafter2=nrow(datat[datat$before==1,])

xtabdata <- data.frame(tr <- c(data$tr,datas_narm$tr, datat$tr),
                       type <- c(data$aa,datas_narm$aa, datat$aa))
chisq.test(xtabs(~tr+type,xtabdata), simulate.p.value = F)

data_all <- xtabdata


####################################
###code to obtain figure 2.3########
####################################
pdata <- split(xtabdata,factor(xtabdata$tr,levels=c("Single", "Before", 
                                                    "After", "Before-6", "After-6")))
paa <- sapply(pdata, function(x) {sum(x[,2]=="aa")/nrow(x)} )
n <- sapply(pdata,function(x){nrow(x)})
aa <- sapply(pdata, function(x) {sum(x[,2]=="aa")} )


png(file=paste(savehere,"aa_percent_5.png",sep="/"),
    width = 10, height = 10,res=300,unit="in")
barplot(paa,col="grey",ylim=c(0,0.7),cex.names=2, cex.axis=2)
for (i in 1:5){
  prop=paste(round(aa[i]/n[i],3)*100,"%",sep="")
  text(1.2*i-0.55, 0.2, prop, cex=1.8)
  text(1.2*i-0.55, 0.16, aa[i], cex=1.8)
  text(1.2*i-0.55, 0.13, "out of", cex=1.8)
  text(1.2*i-0.55, 0.1, n[i], cex=1.8)
  
}

for (i in 2:5){
  x0<- 0.5
  y0<- 0.5+0.03*(i-1)
  y1 <- y0 + 0.01
  xx0 <- 1.2*i-0.5
  segments(x0,y0,x0,y1)
  segments(xx0,y0,xx0,y1)
  segments(x0,y1,xx0,y1)
  test <- prop.test(rbind(table(pdata[[1]][,2]),table(pdata[[i]][,2])))$p.value
  text(0.5*(x0+xx0), y1+0.01,star(test), cex=1.5 )
}

x0<- 1.7
y0<- 0.3
y1 <- y0 + 0.01
xx0 <- 3.1

segments(x0,y0,x0,y1)
segments(xx0,y0,xx0,y1)
segments(x0,y1,xx0,y1)
test <- prop.test(rbind(table(pdata[[2]][,2]),table(pdata[[3]][,2])))$p.value
text(0.5*(x0+xx0), y1+0.01,star(test), cex=1.5 )


x0<- 4.3
y0<- 0.3
y1 <- y0 + 0.01
xx0 <- 5.5

segments(x0,y0,x0,y1)
segments(xx0,y0,xx0,y1)
segments(x0,y1,xx0,y1)
test <- prop.test(rbind(table(pdata[[4]][,2]),table(pdata[[5]][,2])))$p.value
text(0.5*(x0+xx0), y1+0.01,star(test), cex=1.5 )

x0<- 2.3
y0<- 0.35
y1 <- y0 + 0.01
xx0 <- 4.7

segments(x0,y0,x0,y1)
segments(xx0,y0,xx0,y1)
segments(x0,y1,xx0,y1)
test <- prop.test(rbind(table(c(pdata[[2]][,2],pdata[[3]][,2])),
                        table(c(pdata[[4]][,2],pdata[[5]][,2]))))$p.value
text(0.5*(x0+xx0), y1+0.01,star(test), cex=1.5 )

dev.off()


########################################################
#####Code to obtain figure 2.5
##########################################################
#data$pattern <- data$red1
data$type <- data$pattern
AA <- c ('aceace', 'acebce', 'bceace') 
AS <- c('bdfbdf', 'bdfbde', 'bdebdf')
WAA <- c('bcebce')
WAS <- c('bdebde') 
AN <- c('bcebde', 'bdebce', 'acebdf', 'bdface', 'acebde', 'bdeace', 'bcebdf', 'bdfbce')
level=c("AA","WAA","AS","WAS","AN","NM")

for (i in 1:nrow(data))
{
 # data$pattern[i] <- paste(as.vector(data[i,grep('[1-6]$',names(data))]),collapse="")
  data$type[i] <- if (data$pattern[i] %in% AA) "AA"
               else if (data$pattern[i] %in% AS) "AS"
               else if (data$pattern[i] %in% WAA) "WAA"
               else if (data$pattern[i] %in% WAS) "WAS"
               else if (data$pattern[i] %in% AN) "AN"
               else "NM"
}

data$type=factor(data$type,levels=level)

pdata <- split(data,data$tr)

png(file=paste(savehere,"6choice_pattern.png",sep="/"),
    width = 16, height = 8,res=300,unit="in")
par(mfrow=c(1,2))
for (j in 1:2){
  pattern <- table(pdata[[j]]$type)
  n <- nrow(pdata[[j]])
  barplot(pattern/n,col="grey",ylim=c(0,0.5),cex.names=1.5, cex.axis=1.5, main = names(pdata)[j],
          cex.main=2, names.arg=c(expression(AA^r), expression(WAA^r), 
                                  expression(AS^r), expression(WAS^r),
                                   expression(AN^r), expression(NM^r)))
  for (i in 1:6){
    prop=paste(round(pattern[i]/n,3)*100,"%",sep="")
    text(1.2*i-0.55, 0.05, prop, cex=1.5)
    text(1.2*i-0.55, 0.02, paste("n=", pattern[i], sep=""), cex=1.5)
  }
  
  text(6, 0.6, paste("N=", n, sep=""), cex=1.5)
}
dev.off()

fisher.test(table(data$type,data$tr))

############################
######tests#################
############################
data$AAAS <- data$type=="AA"|data$type=="AS"
data$AA <- data$type=="AA"

prop <- table(list(data$AAAS,data$before))
prop <- rbind(prop,prop[1,]+prop[2,] ) 

prop.test(prop[2,],prop[3,])
binom.test(prop[2,],prop[3,])


##test of equal probability in before and after##
chisq.test(table(datat$pattern[datat$before==1]))
chisq.test(table(datat$pattern[datat$before==0]))

propb <- rbind(table(data$aa[data$before=="Before"]),table(datas$pattern))
propa <- rbind(table(data$aa[data$before=="After"]),table(datas$pattern))
prop.test(propb)
prop.test(propa)

##########################
###Follow-up study##########
##########################


# Read and process data
data_add <- read.csv('Follow_up_data_additional.csv',colClasses="character")

data_add <- data_add[as.numeric(data_add$subID)>=900,]

data_single <- data_add[data_add$tr=="s1"|data_add$tr=="s2",]
cc<- do.call(rbind,sapply(data_single$pattern,strsplit,split=""))[,2]
data_single$pattern <-cc

data_single$aa <- "naa"
data_single$aa[data_single$pattern=="a"]<-"aa"
data_before <- data_add[data_add$tr=="b1"|data_add$tr=="b2",]
data_before$aa <- "naa"
data_before$aa[data_before$pattern=="aa"]<- "aa"
data_new <- rbind(data_before,data_single)
data_new$tr <- toupper(data_new$tr)

xtabdata <- data.frame(tr<-data_new$tr,type<-data_new$aa)

colnames(xtabdata) <- c("tr", "type")
colnames(data_all) <- colnames(xtabdata)
data_all <- rbind(data_all, xtabdata)

###################################
###code to obtain figure 3.1########
###################################
pdata <- split(xtabdata,factor(xtabdata$tr,levels=c("S2", "S1", 
                                                    "B2", "B1")))
paa <- sapply(pdata, function(x) {sum(x[,2]=="aa")/nrow(x)} )
n <- sapply(pdata,function(x){nrow(x)})
aa <- sapply(pdata, function(x) {sum(x[,2]=="aa")} )


png(file=paste(savehere,"aa_percent_additional.png",sep="/"),
    width = 10, height = 10,res=300,unit="in")
barplot(paa,col="grey",ylim=c(0,0.6),cex.names=2, cex.axis=2,
        names.arg =c("Single","Single-BL", "Before-B", "Before-BL") )
for (i in 1:5){
  prop=paste(round(aa[i]/n[i],3)*100,"%",sep="")
  text(1.2*i-0.55, 0.2, prop, cex=1.8)
  text(1.2*i-0.55, 0.16, aa[i], cex=1.8)
  text(1.2*i-0.55, 0.13, "out of", cex=1.8)
  text(1.2*i-0.55, 0.1, n[i], cex=1.8)
  
}

brackets(0.5,0.48, 1.9, 0.48, lwd=1, h=0.02)
brackets(3.3,0.48, 4.6, 0.48, lwd=1, h=0.02)

x0 <- 1.2
y0 <- 0.52
xx0 <- 3.9
y1 <- 0.54
segments(x0,y0,x0,y1)
segments(xx0,y0,xx0,y1)
segments(x0,y1,xx0,y1)
text(2.7, 0.56, "*", cex=2 )


dev.off()

###################################
###code to obtain figure B.1########
###################################

xtabdata <- data.frame(pattern=data_new$aa,tr=data_new$tr)


bf<-contingencyTableBF(table(xtabdata), sampleType = "poisson")


chains = posterior(bf, iterations = 10000)
aaGivenB1 = chains[,"lambda[1,1]"] / (chains[,"lambda[1,1]"]+chains[,"lambda[2,1]"]) 
aaGivenB2 = chains[,"lambda[1,2]"] / (chains[,"lambda[1,2]"]+chains[,"lambda[2,2]"])  
aaGivenS1 = chains[,"lambda[1,3]"] / (chains[,"lambda[1,3]"]+chains[,"lambda[2,3]"]) 
aaGivenS2 = chains[,"lambda[1,4]"] / (chains[,"lambda[1,4]"]+chains[,"lambda[2,4]"]) 


png(file=paste(savehere,"bfplotsS1S2.png",sep="/"),   
    width = 4.5, height = 4.5,res=300,unit="in")

    plot(mcmc(aaGivenS1 - aaGivenS2), main = expression(paste("Change in ", SAA^r, " \n  (Single_BL - Single)", sep="")),pars=list(par(mfcol=c(1,1))),lwd=3, 
         cex.main=1,xlab="")
    abline(v=0,lty=2)
dev.off()

png(file=paste(savehere,"bfplotsB1B2.png",sep="/"),   
    width = 4.5, height = 4.5,res=300,unit="in")
    plot(mcmc(aaGivenB1 - aaGivenB2), main = expression(paste("Change in ", SAA^r, " \n  (Before_BL - Before_B)", sep="")),pars=list(par(mfcol=c(1,1))),
         cex.main=1,xlab="",lwd=3)
    abline(v=0,lty=2)
dev.off()

png(file=paste(savehere,"bfplotsB1S1.png",sep="/"),   
    width = 4.5, height = 4.5,res=300,unit="in")
    plot(mcmc(aaGivenB1 - aaGivenS1), main = expression(paste("Change in ", SAA^r, " \n  (Before_BL - Single_BL)", sep="")),pars=list(par(mfcol=c(1,1))),
         cex.main=1,xlab="",lwd=3)
    abline(v=0,lty=2)
dev.off()

png(file=paste(savehere,"bfplotsB2S2.png",sep="/"),   
    width = 4.5, height = 4.5,res=300,unit="in")
    plot(mcmc(aaGivenB2 - aaGivenS2), main = expression(paste("Change in ", SAA^r, " \n  (Before_B - Single)", sep="")),pars=list(par(mfcol=c(1,1))),
         cex.main=1,xlab="",lwd=3)
    abline(v=0,lty=2)

dev.off()

